/*
 * EtherPix config file generator
 *
 * Copyright 2010-2017 Stefan Schuermans <stefan schuermans info>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 *
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef INC_CHAIN_H
#define INC_CHAIN_H

#include <iostream>
#include <vector>

#include "pixel.h"
#include "point.h"

class Chain {
public:
  Chain(unsigned int pixelCnt);
  void addPixel(Pixel const &pixel);
  int pixCoord(const Point &pix0, const Point &pixSz,
               unsigned int width, unsigned int height,
               unsigned int distriNo, unsigned int chainNo);
  void writePixels(std::ostream & strm) const;
  size_t countPixels() const;
private:
  unsigned int mPixelCnt;
  std::vector<Pixel> mPixels;
};

#endif // #ifndef INC_CHAIN_H

